package config

import (
	"os"
	"path"
	"path/filepath"
	"runtime/debug"
)

var (
	Executable string
	Root       string
	Library    string
)

func init() {
	debug.SetGCPercent(-1)
	executable, err := os.Executable()

	if err != nil {
		panic(err)
	}

	Executable = executable
	Root = filepath.Dir(executable)
	Library = filepath.Join(Root, "lib")
	stat, err := os.Stat(Library)

	if !os.IsNotExist(err) && stat != nil && stat.IsDir() {
		return
	}

	dir, err := os.Getwd()

	if err != nil {
		panic(err)
	}

	for {
		Library = path.Join(dir, "lib")
		stat, err := os.Stat(Library)

		if !os.IsNotExist(err) && stat != nil && stat.IsDir() {
			return
		}

		if dir == "/" {
			panic("standard library not found")
		}

		dir = filepath.Dir(dir)
	}
}
