package core

import (
	"git.akyoto.dev/cli/q/src/build/config"
	"git.akyoto.dev/cli/q/src/build/scope"
)

// AddVariable adds a new variable to the current scope.
func (f *Function) AddVariable(variable *scope.Variable) {
	if config.Comments {
		f.Comment("%s = %s (%d uses)", variable.Name, variable.Register, variable.Alive)
	}

	s := f.CurrentScope()
	variable.Scope = s

	if s.Variables == nil {
		s.Variables = map[string]*scope.Variable{}
	}

	s.Variables[variable.Name] = variable
	s.Use(variable.Register)
}
