package core

import (
	"git.akyoto.dev/cli/q/src/build/asm"
	"git.akyoto.dev/cli/q/src/build/cpu"
	"git.akyoto.dev/cli/q/src/build/fs"
	"git.akyoto.dev/cli/q/src/build/scope"
	"git.akyoto.dev/cli/q/src/build/token"
)

// Function represents the smallest unit of code.
type Function struct {
	scope.Stack
	Name            string
	File            *fs.File
	Body            []token.Token
	Assembler       asm.Assembler
	Functions       map[string]*Function
	Err             error
	registerHistory []uint64
	finished        chan struct{}
	cpu             cpu.CPU
	count           counter
}

// counter stores how often a certain statement appeared so we can generate a unique label from it.
type counter struct {
	branch    int
	data      int
	loop      int
	subBranch int
}
