package token

// Operators is a map of all operators used in the language.
var Operators = map[string]Kind{
	".":   Period,
	"=":   Assign,
	":=":  Define,
	"+":   Add,
	"-":   Sub,
	"*":   Mul,
	"/":   Div,
	"%":   Mod,
	"&":   And,
	"|":   Or,
	"^":   Xor,
	"<<":  Shl,
	">>":  Shr,
	"&&":  LogicalAnd,
	"||":  LogicalOr,
	"!":   Not,
	"==":  Equal,
	"!=":  NotEqual,
	">":   Greater,
	"<":   Less,
	">=":  GreaterEqual,
	"<=":  LessEqual,
	"+=":  AddAssign,
	"-=":  SubAssign,
	"*=":  MulAssign,
	"/=":  DivAssign,
	"%=":  ModAssign,
	"&=":  AndAssign,
	"|=":  OrAssign,
	"^=":  XorAssign,
	"<<=": ShlAssign,
	">>=": ShrAssign,
	"λ":   Call,
	"@":   Array,
}
