package cli

import (
	"fmt"
	"os"
	"runtime"
)

// System shows system information.
func System(args []string) int {
	line := "%-19s%s\n"

	fmt.Printf(line, "Platform:", runtime.GOOS)
	fmt.Printf(line, "Architecture:", runtime.GOARCH)
	fmt.Printf(line, "Go:", runtime.Version())

	// Directory
	directory, err := os.Getwd()

	if err == nil {
		fmt.Printf(line, "Directory:", directory)
	} else {
		fmt.Printf(line, "Directory:", err.Error())
	}

	// Compiler
	executable, err := os.Executable()

	if err == nil {
		fmt.Printf(line, "Compiler:", executable)
	} else {
		fmt.Printf(line, "Compiler:", err.Error())
	}

	return 0
}
